﻿using System;
using System.Net;
using System.Net.Sockets;

class MyTcpListener
{
    public static void Main()
    {
        Server("127.0.0.1", 8080);
    }

    public static void ReplytoGETRequest(NetworkStream stream)
    {
        String data = "";
        Byte[] bytes = new Byte[256];

        data =
            "HTTP/1.1 200 OK" + "\r\n" +
            "Connection: close" + "\r\n" +
            "\r\n" +
            "<!DOCTYPE html>" + "\r\n" +
            "<html>" + "\r\n" +
            "<head>" + "\r\n" +
            "<title>Coucou</title>" + "\r\n" +
            "</head>" + "\r\n" +
            "<body>" + "\r\n" +
            "Cette page est une page toute simple" + "\r\n" +
            "</body>" + "\r\n" +
            "</html>" + "\r\n" +
            "\r\n";

        Console.WriteLine("Sent: {0}\n", data);

        byte[] msg = System.Text.Encoding.ASCII.GetBytes(data);

        // Send back HTML response.
        stream.Write(msg, 0, msg.Length);

    }

    static void Server(String server_addr, Int32 port)
    {
        TcpListener server = null;

        // Set the TcpListener on port
        IPAddress localAddr = IPAddress.Parse(server_addr);

        // TcpListener server = new TcpListener(port);
        server = new TcpListener(localAddr, port);

        // Start listening for client requests.
        server.Start(1);

        // Buffer for reading data
        Byte[] bytes = new Byte[256];
        String data = null;

        // Enter the listening loop.

        {

            Console.Write("Waiting for a connection... ");

            // Perform a blocking call to accept requests.

            TcpClient client = server.AcceptTcpClient();
            Console.WriteLine("Connected!");

            data = null;

            // Get a stream object for reading and writing
            NetworkStream stream = client.GetStream();

            int i;
            i = stream.Read(bytes, 0, bytes.Length);
            Console.WriteLine("Received: {0}", data);

            // Loop to receive all the data sent by the client.
            /*while ((i = stream.Read(bytes, 0, bytes.Length)) != 0)
            {
                // Translate data bytes to a ASCII string.
                data = System.Text.Encoding.ASCII.GetString(bytes, 0, i);
                Console.WriteLine("Received: {0}", data);

            }*/

            // stream.Flush();
            ReplytoGETRequest(stream);
            // Shutdown and end connection

            Console.WriteLine("\nHit enter before quit...");
            Console.ReadLine();

            client.Close();

            Console.WriteLine("\nWaiting for a new connection and a new request...");


        }
    }
}